

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   RAYO Batch 1.02                                               *
    *   Copyright  2004 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under AFPL.                      *
    *   See AFPL.htm for details.                        2004-08-11   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



#include "class_cjoblist.h"

CJobList::CJobList()
{
	first = NULL;
	last = NULL;
	uMax = 0;
}

CJobList::~CJobList()
{
	while( first != NULL )
	{
		last = first->next;
		delete first;
		first = last;
	}
}

void CJobList::queue( char * filename, UINT uLen )
{
	static UINT uCalls = 0;
	if( uCalls++ == 0 ) return;

	uMax++;

	CJob * job = new CJob( filename, uLen );
	if( first == NULL )
	{
		// list empty
		first = job;
		last = job;
	}
	else
	{
		last->next = job;
		last = job;
	}
}

bool CJobList::dequeue( char * filename )
{
	if( first == NULL ) return false;

	strcpy( filename, first->filename );
	
	CJob * kick = first;
	first = first->next;
	delete kick;

	return true;
}
